#!/usr/bin/perl -w
use strict;

##############################################################################################################
#Read files
sub ReadFiles {
	my($sequences, $genenames, $input)	= @_;
	my(@clusterlines)       		= ();
	my($line)               		= ();
	my($fastanum)				= -1;
	
	@clusterlines = split(/\n/, $input);
	foreach $line (@clusterlines) {
		if    ($line =~ m/^\s*$/) { next; }
       		elsif ($line =~ m/^\s*#/) { next; }
		elsif ($line =~ m/^\s*>/) {                     #FASTA FORMATED HEADER LINES START WITH > -CHAR
			$line =~ s/\n|\r//gi;                   #REMOVE EMPTY CHARS
			++$fastanum;                            #WHEN THE FIRST HEADER IS FOUND c IS PUT TO ZERO
			@$sequences[$fastanum] = "";             #STORE EMPTY STRING
			@$genenames[$fastanum] = $line;          #STORE HEADER ROW
			next;
		} else {
			if ($fastanum != -1) {
				$line =~ s/\s//g;
				@$sequences[$fastanum] .= $line;
			}
		}
	}
	return($fastanum);
}
############################################################################################################## 
1;
