#!/usr/bin/perl -w
use strict;

#################################################################################################################
sub StringCountOverlap {
	my($plus, $is_input, $search_motif, $sequence_length, $seq_name) = @_;
	my($mins) = "";					#the reverse strand
	my($len_sequence) = 0;				#lenght of the sequence
	my($plus_count) = 0;				#counter of occurances in plus strand (input)
	my($mins_count) = 0;				#counter of occurances in mins strand (reverse)
	my($help_motif) = "";				#help motif (used in printing)
	my($sum) = 0;					#number of motifs in sequene
	my($start_pos) = 0;				#place in the sequence (end position)
	my($end_pos) = 0;				#place in the sequence (start position)
	my($pattern_len) = 0;				#length of the pattern
	my($seq_print) = "";				#print sentence of the sequence length

	($len_sequence) = length($plus);
	if ($len_sequence >= $sequence_length ) { $seq_print = "$seq_name is $len_sequence bp, $sequence_length bp used"; }
	if ($len_sequence <  $sequence_length ) { $seq_print = "$seq_name is $len_sequence bp, $len_sequence bp used"; }
	if ($len_sequence >= $sequence_length ) {$plus = substr($plus,($len_sequence - $sequence_length),$sequence_length)}
	$mins = reverse($plus);
	$mins =~ tr/AaCcGgTt/TtGgCcAa/;

	$plus =~ /$search_motif/i;
	$pattern_len = length($&);
	while($plus =~ /(?=$search_motif)/ig) {	
		++$plus_count;
		if ($is_input != 0) {
			$start_pos = (length($plus) - pos($plus));
			$end_pos = ($start_pos - $pattern_len);
			$help_motif = substr($plus, pos($plus), $pattern_len);
			print FP "#$seq_name\tPOBO\tmisc_feature\t-$start_pos\t-$end_pos\t.\t+\t.\t$help_motif\t$seq_print\n";
			#print FP "#\t+$start_pos\t$help_motif-[N$end_pos]-TSS/ATG\n";
		}
	}

 	$mins =~ /$search_motif/i;
	$pattern_len = length($&);
        
	while($mins =~ /(?=$search_motif)/ig){
		++$mins_count;
		if ($is_input != 0) {
			$start_pos = (pos($mins));
			$end_pos = ($start_pos + $pattern_len);
			$help_motif = substr($mins, pos($mins), $pattern_len);
			$help_motif = reverse($help_motif);
			$help_motif =~ tr/AaCcGgTt/TtGgCcAa/;
			print FP "#$seq_name\tPOBO\tmisc_feature\t-$end_pos\t-$start_pos\t.\t-\t.\t$help_motif\t$seq_print\n"; 
			#print FP "#\t-$end_pos\t$help_motif-[N$start_pos]-TSS/ATG\n";
		}
	}

	$sum = ($plus_count + $mins_count);
	return $sum;
}
############################################################################################################## 
1;
